/*
 * Created on Nov 3, 2003
 */
package org.ninjasoft.wmap;

import java.util.*;
import java.io.*;

/**
 * @author enigma
 */
public class ConsoleUi {
    private int delay = 0;
    
    public ConsoleUi() {
    }
    
    public void runAutomatic(String base) {
        AutoList list = null;
        Vector found = new Vector();
        Vector forbidden = new Vector();
        if (!base.endsWith("/"))
            base = base + "/";
        try{
            list = new AutoList();
        }catch(Exception e){
            System.err.println("Unable to open auto folder list");
            e.printStackTrace();
            return;
        }
        for (Iterator i = list.getIterator(); i.hasNext(); ) {
            AutoList.AutoTouple touple = (AutoList.AutoTouple) i.next();
            String[] results = TryUrl.tryUrl(base, touple.directory, null);
            for (int j=0; j<results.length; j++){
                String result = results[j];
                printResult(result);
                if (result.startsWith("2"))
                    found.add(touple);
                else if (result.startsWith("403"))
                    forbidden.add(touple);
            }
            if (i.hasNext())
                this.doDelay(this.delay);
        }
        System.out.println("\nResults:");
        for (Iterator i = found.iterator(); i.hasNext(); ) {
            AutoList.AutoTouple touple = (AutoList.AutoTouple) i.next();
            System.out.println("EXISTS, LOADS         " + base + touple.directory);
        }
        for (Iterator i = forbidden.iterator(); i.hasNext(); ) {
            AutoList.AutoTouple touple = (AutoList.AutoTouple) i.next();
            System.out.println("EXISTS, NOT BROWSABLE " + base + touple.directory);
        }
    }
    
    public void runManual(String base) {
        LineNumberReader in = new LineNumberReader(new InputStreamReader(System.in));
        while (true) {
            System.out.print("Enter directory/file name to search for at base URL (enter to quit)\n> ");
            String dir = null;
            try{
                dir = in.readLine();
            }catch(IOException e){}
            if (dir == null)
                dir = "";
            dir = dir.trim();
            if (dir.length() == 0)
                return;
            String[] results = TryUrl.tryUrl(base, dir, AutoList.EXT);
            for (int i=0; i<results.length; i++)
                printResult(results[i]);
        }
    }
    
    private void printResult(String line) {
        System.out.print(line);
        if (line.startsWith("2") || line.startsWith("403"))
            System.out.print(" <<<<<<<<<<");
        System.out.print("\n");
    }
    
    public void setDelay(int seconds) {
        this.delay = seconds;
    }
    
    private void doDelay(int seconds) {
        try{ Thread.sleep(seconds * 1000); } catch(InterruptedException ie) {}
    }
}
