/*
 * Created on Nov 3, 2003
 */
package org.ninjasoft.wmap;

import java.io.IOException;
import java.net.*;
import java.util.*;
import java.text.DecimalFormat;

/**
 * @author enigma
 */
public class TryUrl {
    private static DecimalFormat formatter = new DecimalFormat("###");
    public static String[] tryUrl(String base, String extended, String[] extensions) {
        Vector result = new Vector();
        // Ensure base ends with a slash
        if (!base.endsWith("/"))
            base = base + "/";
        // Ensure extended does not end in a slash
        if (extended.endsWith("/"))
            extended = extended.substring(0, extended.length() - 1);
        
        // First, try the base as a folder
        result.add(tryUrl(base + extended + "/"));
        
        // Next try all extensions (if given)
        if (extensions != null) {
            for (int i=0; i<extensions.length; i++) {
                String ext = extensions[i];
                if (!ext.startsWith("."))
                    ext = "." + ext;
                result.add(tryUrl(base + extended + ext));
            }
        }
        String[] resultStr = new String[result.size()];
        for (int i=0; i<resultStr.length; i++)
            resultStr[i] = (String) result.get(i);
        return resultStr;
    }
    
    public static String tryUrl(String url) {
        try{
            StringBuffer result = new StringBuffer();
            URL urlObject = new URL(url);
            HttpURLConnection conn = (HttpURLConnection) urlObject.openConnection();
            conn.setRequestMethod("HEAD");
            conn.connect();
            int code = conn.getResponseCode();
            result.append(formatter.format(code));
            result.append(" ");
            result.append(url);
            return result.toString();
        }catch(IOException e) {
            e.printStackTrace();
            return "000 " + url;
        }
    }

    public static void main(String[] argv) throws Exception {
        System.out.println(tryUrl("http://netninja.com/images/"));
        System.out.println(tryUrl("http://netninja.com/abcxyz/"));
    }
}
